public class Garcon extends Homme {

    Garcon(String nom) {
        // exemple de la 3ème utilisation de this : le caînage de constructeurs
        // dans ce cas, on appelle le constrcteur jsute en dessous, qui lui-même appelle
        // le constructeur général.
        this(0,0,nom,0);
    }

    Garcon(int age, int poids, String nom, int batifolage) {
        super(age, poids, nom, 0, batifolage);
    }

    /* Rq : cette méthode est la même que celle de Fille. Cela serait donc bien de pouvoir eviter cette copie
       en mettant le code dans une super-classe commune. Le problème est que cette classe est Humain.
       Or, a cause de super.rencontre(), Il est donc impossible de mettre cette méthode dans Humain.
       On est donc bien obligé de la copier/coller dans Garcon et Fille.
     */
    public Humain rencontre (Humain h, boolean doGrowth) {
        // stoppe immédiatement si h pas adulte
        if (h.isGarcon() || h.isFille() ) return null;
        // sinon on utilise la super méthode.
        Humain bebe = super.rencontre(h, doGrowth);
        return bebe;
    }

    public boolean isGarcon() { return true;}
}
